package apt.city;

import apt.Display;
import java.awt.*;

/**
 *
 * This class draws the blinking cursor logo for the
 * piece, and acts as a button, firing off an event when clicked.
 *
 */
class LogoButton extends apt.BufferPanel implements Runnable
{
    private Thread blinking;
    private boolean cursorVisible;
    private String message1="Create";
    private String message2="";
    private boolean mouseInside;
    

    protected void drawOffscreen(Graphics g)
    {
        clearBuffer();
        g.setColor(mouseInside ? getForeground() : 
                                 Display.getDefaultDisplay().midcolor());

        int cy=20, cx=5;

        // draw arrow.
        g.drawLine(cx,cy,cx+4,cy-4);
        g.drawLine(cx,cy-8,cx+4,cy-4);

        //if (cursorVisible)
            g.fillRect(cx+7,cy-12, 8, 14);

        g.setFont(getFont());
        
        //cy+=20;
        cx+=20;
        
        g.drawString(message1, cx, cy+1);
        int sw=getFontMetrics(getFont()).stringWidth(message1);
        //g.drawLine(cx,cy+1,cx+sw,cy+1);
        g.drawString(message2, cx, cy+17);
    }
    
    public boolean mouseEnter(Event e, int x, int y)
    {
        mouseInside=true;
        redraw();
        return true;
    }
    
    public boolean mouseExit(Event e, int x, int y)
    {
        mouseInside=false;
        redraw();
        return true;
    }

    public boolean mouseDown(Event e, int x, int y)
    {
        //System.out.println("LogoButton, mouse down.");
        postEvent(new Event(this, Event.ACTION_EVENT, null));
        return true;
    }

    public void run()
    {
        while (blinking==Thread.currentThread())
        {
            redraw();
            cursorVisible=!cursorVisible;
            try {Thread.sleep(500);} catch (Exception e) {}
        }
    }

    public void start()
    {
        //blinking=new Thread(this);
        //blinking.start();
    }

    public void stop()
    {
        blinking=null;
    }
}