package apt.plan2d;

import english.words.*;
import java.util.*;
import java.net.*;
import java.io.*;

/**
 *
 * This class holds information about the words which
 * define, or make up, a room of the apartment.
 *
 */
public class RoomDefinition
{
    Hashtable roomTable=new Hashtable();
    Hashtable numberTable=new Hashtable();
    Hashtable wordTable=new Hashtable();
    Vector roomNames=new Vector();

    public RoomDefinition() {}


    public Vector getRoomNames()
    {
        return roomNames;
    }

    public String getRoomName(int number)
    {
        return (String)roomNames.elementAt(number);
    }

    public int getRoomNumber(String word)
    {
        String room=getRoom(word);
        if (room==null) return -1;
        return ((Integer)numberTable.get(room)).intValue();
    }
    
    public String root(String word)
    {
        return WordReference.lookUpKey(word, roomTable);
    }

    public String getRoom(String word)
    {
        return (String)WordReference.lookUp(word, roomTable);
    }

    public Word getWord(String word)
    {
        return (Word)WordReference.lookUp(word, wordTable);
    }

    public void readDefinition(InputStream in) throws IOException
    {
        DataInputStream data=new DataInputStream(in);
        String line=null;
        String room="empty";
        boolean newRoom=true;
        int r=0;
        int total=0;
        int roomNumber=0;
        while (null != (line=data.readLine()))
        {
            line=line.trim();
            if (line.length()==0) continue;
            if (line.charAt(0)=='#') continue;
            if (line.equals("*"))
            {
                //System.out.println("words for "+room+": "+r);
                r=0;
                newRoom=true;
                continue;
            }
            if (newRoom)
            {
                StringTokenizer rt=new StringTokenizer(line,": ");
                room=rt.nextToken();
                newRoom=false;
                numberTable.put(room, new Integer(roomNumber));
                roomNames.addElement(room);
                roomNumber++;
            }
            StringTokenizer t=new StringTokenizer(line);
            while (t.hasMoreElements())
            {
                String code=t.nextToken();
                Word pw=new Word(code);
                wordTable.put(pw.word, pw);
                roomTable.put(pw.word, room);
                r++;
                total++;
            }
        }
        data.close();
        in.close();
        //System.out.println("\ntotal = "+total);
    }

}