package apt.plan3d;

/**
 *
 * An interface that represents a surface that has
 * some sort of grid (e.g. a NURBS surface or an indexed
 * face set) as well as a label.
 *
 */
public interface WordSurface
{
    /** 
     *
     * Get the grid of points that
     * help define the geometry of this WordSurface. 
     *
     * @return a 2D array of Point3D objects.
     *
     */
    public space.Point3D[][] getGrid();

    /** 
     * 
     * Get the String label associated with this surface.
     *
     * @return a String label for this surface.
     *
     */
    public String getWord();
}
