package apt.servlet;

import apt.vrml.*;
import apt.plan3d.WordSurface;
import com.bewitched.servlet.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;

/**
This servlet writes a VRML file.
To make your own, change the line indicated in the comment below.
*/
public class Make3D extends HttpServlet
{
    private final String ERROR_SIGNAL="error";

    public void doPost(HttpServletRequest req, HttpServletResponse res)
                throws ServletException, IOException
    {
        res.setContentType("text/html");
        PrintWriter out=res.getWriter();
        String id=req.getParameter("id");
        String data=req.getParameter("roominfo");
        String tourValues=req.getParameter("tour");
        try
        {
            String fileName=ApartmentPath.vrmlFile(id);

            RoomInfo[] info=RoomIO.readAll(data);
            File file=new File(fileName);
            FileWriter writer=new FileWriter(file);

            StringTokenizer t=new StringTokenizer(tourValues,",");
            int n=t.countTokens();
            int[] tour=new int[n];
            for (int i=0; i<n; i++)
                tour[i]=Integer.parseInt(t.nextToken());

            // ***********************************
            // PUT YOUR OWN CONVERTER HERE!!!
            new AtLastItsTheVRMLConverter().writeToVRML(
                info, tour, writer
            );
            // **********************************

            writer.close();

            out.println(fileName);
            out.println("number of rooms="+info.length);

        }
        catch (Exception e)
        {
            out.println(ERROR_SIGNAL);
            out.println(e);
        }

    }

    private void notNull(String what, Object o)
    {
        if (o==null) throw new NullPointerException(what+" was null!");
    }

    private void appendln(StringBuffer b, String s)
    {
        b.append(s);
        b.append(TextFile.CRLF);
    }
}
