package apt.vrml;

import apt.*;
import apt.plan2d.*;
import apt.plan3d.*;
import java.io.*;
import java.util.*;
import space.*;

// this was written in a real hurry.
//
// watch out.

public class RoomIO
{
    public static final String BEGIN_ROOM="BEGIN-ROOM",
                               END_ROOM="END_ROOM";
    
                               
    public static RoomInfo[] exampleInfo(File file) throws IOException
    {
        
        FileReader r=new FileReader(file);
        RoomInfo[] w= read(new BufferedReader(r));
        r.close();
        //System.out.println(writeAllToString(w));
        return w;
    }
    
    /**
     *
     * Run a simple test to make sure everything works,
     * by translating the given infos to strings, back
     * to infos, and to strings again, and comparing the
     * strings.
     *
     */
    public static void test(RoomInfo[] r)
    {
        System.out.println("RoomIO.test:");
        try
        {
            String s1=writeAllToString(r);
            RoomInfo[] w=readAll(s1);
            String s2=writeAllToString(w);
            
            System.out.println("orig. len: "+r.length);
            System.out.println(" copy len: "+w.length);
            
            if (s1.equals(s2))
            {
                System.out.println("!!! IT WORKED !!!");
            }
            else
            {
                System.out.println("No luck.");
                //System.out.println("#1:"+s1);
                //System.out.println("#2:"+s2);
            }
        }
        catch (Exception e)
        {
            System.out.println("RoomIO.test: "+e);
        }
    }
    
    public static RoomInfo[] read(Reader reader) throws IOException
    {
        BufferedReader in=new BufferedReader(reader);
        Vector v=new Vector();
        RoomInfo r=null;
        while (null !=(r=readNextRoom(in)))
            v.addElement(r);
        int n=v.size();
        RoomInfo[] rooms=new RoomInfo[n];
        for (int i=0; i<n; i++)
            rooms[i]=(RoomInfo)v.elementAt(i);
        return rooms;
    }
    
    private static RoomInfo readNextRoom(BufferedReader in)
    {
        try
        {
            readUntil(BEGIN_ROOM, in);
            RoomInfo r=new RoomInfo(readValue("name", in));
            Point3D a=pointFromString(readValue("corner1", in));
            Point3D b=pointFromString(readValue("corner2", in));
            r.setCorners(a,b);
            WordSurface[] w=WordSurfaceIO.readAll(in);
            for (int i=0; i<w.length; i++)
                r.addWordSurface(w[i]);
            return r;
        }
        catch (Exception e)
        {
            return null;
        }
    }
    
    public static RoomInfo[] readAll(String s) throws IOException
    {
        BufferedReader b=new BufferedReader(new StringReader(s));
        RoomInfo[] w= read(b);
        b.close();
        return w;
    }
    
    public static String writeAllToString(RoomInfo[] info) throws IOException
    {
        StringWriter w1=new StringWriter();
        write(info, new PrintWriter(w1));
        w1.flush();
        w1.close();
        return w1.toString();
    }
    
    private static Point3D pointFromString(String s)
    {
        StringTokenizer g=new StringTokenizer(s,", ");
        return new Point3D(
            Double.valueOf(g.nextToken()).doubleValue(),
            Double.valueOf(g.nextToken()).doubleValue(),
            Double.valueOf(g.nextToken()).doubleValue()
        );
    }
    
    public static void write(RoomInfo[] room, Writer writer) throws IOException
    {
        PrintWriter p=new PrintWriter(writer);
        for (int i=0; i<room.length; i++)
        {
            //p.println("i="+i);
            if (room[i]==null) continue;
            //p.println("...i="+i);
            p.println(BEGIN_ROOM);
            p.println("name="+room[i].getName());
            p.println("corner1="+printPoint(room[i].getCorners()[0]));
            p.println("corner2="+printPoint(room[i].getCorners()[1]));
            WordSurface[] w=room[i].getWordSurfaces();
            WordSurfaceIO.writeAll(w, p);
            p.println(WordSurfaceIO.END_SEGMENT);
            p.println(END_ROOM);

        }
        p.flush();
    }
    
    final static String printPoint(Point3D q)
    {
        return format(q.x)+","+format(q.y)+","+format(q.z);
    }

    final static String format(double q)
    {
        double r=Math.round(100*q)/100.0;
        String m=String.valueOf(r);
        // deal with floating point weirdness.
        int n=m.indexOf('.');
        if (n>=0 && m.length()-n>3) m=m.substring(0,n+3);

        return m;
    }
    
    
    private static String readValue(String s, BufferedReader in) throws IOException
    {
        String line=readUntil(s,in);
        StringTokenizer t=new StringTokenizer(line,"=");
        t.nextToken();
        return t.nextToken();
    }
    
    private static String readUntil(String s, BufferedReader in) throws IOException
    {
        String line=null;
        do 
        {
            line=in.readLine();
            //System.out.println("ru: "+line);
        } while (line.indexOf(s)!=0);
        return line;
    }
    
}
