package english.words;

import java.util.*;

/**
 *
 * Object that represents an English word.
 *
 */
public class Word
{
    public String word;
    public String pos;
    public boolean noun, adj, adv, verb, intrans,
            proper, pronoun, directObj;

    public Word(String code)
    {
        StringTokenizer t=new StringTokenizer(code,":");
        word=t.nextToken();
        if (t.hasMoreTokens())
        {
            pos=t.nextToken();
            adj=pos.indexOf("j")    !=-1;
            adv=pos.indexOf("b")    !=-1;
            intrans=pos.indexOf("i")!=-1;
            verb=intrans || pos.indexOf("v")   !=-1;
            pronoun=pos.indexOf("r")   !=-1;
            proper=pronoun || pos.indexOf("p") !=-1;
            directObj=pos.indexOf("o")   !=-1;
            noun=pronoun || proper || directObj ||
                 pos.indexOf("n")   !=-1;
        }
        else
        {
            noun=true;
            proper=true;
        }
    }

    public Word variant(String variantWord)
    {
        return new Word(variantWord+":"+(pos==null ? "" : pos));
    }

    public String toString()
    {
        return word+":"+pos;
    }
}