package space;

import java.awt.*;
import java.util.*;

public class Viewpoint
{
    public Matrix3D angle;
    public Point3D light;
    public Point3D eye;
    public double d, scale;
    public int ox,oy;

    public Viewpoint(Matrix3D angle, Point3D light, double d, double scale,
                     int ox, int oy) {
        this.angle=angle;
        this.light=light;
        this.d=d;
        this.scale=scale;
        this.ox=ox;
        this.oy=oy;
        eye=angle.inverse().times(new Point3D(0,0,d));
    }

    public void project(Point3D space, Point plane)
    {
        double x=angle.a11*space.x+angle.a12*space.y+angle.a13*space.z;
        double y=angle.a21*space.x+angle.a22*space.y+angle.a23*space.z;
        double z=angle.a31*space.x+angle.a32*space.y+angle.a33*space.z;
        double f=scale/(d-z);
        plane.x=(int)(ox+f*x);
        plane.y=(int)(oy+f*y);
    }

    public void setDistance(double d)
    {
        eye.scale(d/this.d);
        this.d=d;
    }

    public void setAngle(Matrix3D angle)
    {
        this.angle=angle;
        eye=angle.inverse().times(new Point3D(0,0,d));
    }

    public void rotateObjectsTo(Matrix3D angle, Point3D light)
    {
        setAngle(angle);
        this.light=angle.inverse().times(light);
    }
}